diff -u -r -N rdnzl-cpp-0.5.2\RDNZL\DotNetContainer.h rdnzl-cpp-new-cast\RDNZL\DotNetContainer.h
--- rdnzl-cpp-0.5.2\RDNZL\DotNetContainer.h	Tue Jan 03 19:49:54 2006
+++ rdnzl-cpp-new-cast\RDNZL\DotNetContainer.h	Tue May 08 16:57:57 2007
@@ -86,4 +86,5 @@
   __declspec(dllexport) void freeDotNetContainer(void *ptr);
   // function definition is in InvocationResult.cpp
   __declspec(dllexport) void *setDotNetContainerTypeFromString(const __wchar_t *type, void *ptr);
+  __declspec(dllexport) void *setDotNetContainerTypeFromContainer(void *type, void *ptr);
 }
diff -u -r -N rdnzl-cpp-0.5.2\RDNZL\InvocationResult.cpp rdnzl-cpp-new-cast\RDNZL\InvocationResult.cpp
--- rdnzl-cpp-0.5.2\RDNZL\InvocationResult.cpp	Tue Jan 03 19:49:54 2006
+++ rdnzl-cpp-new-cast\RDNZL\InvocationResult.cpp	Tue May 08 17:01:38 2007
@@ -70,23 +70,47 @@
 }
 
 // this should actually be in DotNetContainer.cpp but couldn't be defined there
-__declspec(dllexport) void *setDotNetContainerTypeFromString(const __wchar_t *type, void *ptr) {
-  try {
-    // throw an exception if something happens
-    Type *newType = Type::GetType(type, true);
-    DotNetContainer *container = static_cast<DotNetContainer *>(ptr);
-    Type *oldType = container->getContainerType();
+// Helper function for setDotNetContainerTypeFromString and 
+// setDotNetContainerTypeFromContainer.
+void *setDotNetContainerType(Type *newType, void *ptr) {
+	try {
+		DotNetContainer *container = static_cast<DotNetContainer *>(ptr);
+		Type *oldType = container->getContainerType();
+
+		if (oldType->IsAssignableFrom(newType)) {
+			container->setContainerType(newType);
+		} else {
+			Object *newObject = Convert::ChangeType(container->getContainerObject(), newType);
+			container->setContainerObject(newObject);
+			container->setContainerType(newType);
+		}
+		// return void result
+		return new InvocationResult();
+	} catch (Exception *e) {
+		return new InvocationResult(e, true);
+	}
+}
 
-    if (oldType->IsAssignableFrom(newType)) {
-      container->setContainerType(newType);
-    } else {
-      Object *newObject = Convert::ChangeType(container->getContainerObject(), newType);
-      container->setContainerObject(newObject);
-      container->setContainerType(newType);
-    }
-    // return void result
-    return new InvocationResult();
-  } catch (Exception *e) {
-    return new InvocationResult(e, true);
-  }
+// this should actually be in DotNetContainer.cpp but couldn't be defined there
+// If possible change the type of the DotNetContainer given the string name of a type that will be found in the Load context.
+__declspec(dllexport) void *setDotNetContainerTypeFromString(const __wchar_t *type, void *ptr) {
+	try {
+		// throw an exception if something happens
+		Type *newType = Type::GetType(type, true);
+		return setDotNetContainerType(newType, ptr);
+	} catch (Exception *e) {
+		return new InvocationResult(e, true);
+	}
+}
+    
+// this should actually be in DotNetContainer.cpp but couldn't be defined there
+// Change the type of the DotNetContainer, if possible, given a Type object.
+__declspec(dllexport) void *setDotNetContainerTypeFromContainer(void *type, void *ptr) {
+	try {
+		// throw an exception if something happens
+		Type *newType = static_cast<Type *>(static_cast<DotNetContainer *>(type)->getContainerObject());
+		return setDotNetContainerType(newType, ptr);
+	} catch (Exception *e) {
+		return new InvocationResult(e, true);
+	}
 }
